diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-default-ack-manager.h ns-3.34/src/wifi/model/wifi-default-ack-manager.h
--- ns-3.33/src/wifi/model/wifi-default-ack-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-default-ack-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,151 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_DEFAULT_ACK_MANAGER_H
+#define WIFI_DEFAULT_ACK_MANAGER_H
+
+#include "wifi-ack-manager.h"
+
+
+namespace ns3 {
+
+class WifiTxParameters;
+class WifiMacQueueItem;
+
+/**
+ * \ingroup wifi
+ *
+ * WifiDefaultAckManager is the default ack manager.
+ */
+class WifiDefaultAckManager : public WifiAckManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  WifiDefaultAckManager ();
+  virtual ~WifiDefaultAckManager ();
+
+  virtual std::unique_ptr<WifiAcknowledgment> TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu,
+                                                          const WifiTxParameters& txParams) override;
+  virtual std::unique_ptr<WifiAcknowledgment> TryAggregateMsdu (Ptr<const WifiMacQueueItem> msdu,
+                                                                const WifiTxParameters& txParams) override;
+
+  /**
+   * Get the maximum distance between the starting sequence number of the Block
+   * Ack agreement which the given MPDU belongs to and each of the sequence numbers
+   * of the given MPDU and of all the QoS data frames included in the given TX
+   * parameters.
+   *
+   * \param mpdu the given MPDU
+   * \param txParams the given TX parameters
+   * \return the maximum distance between the starting sequence number of the Block
+   *         Ack agreement which the given MPDU belongs to and each of the sequence
+   *         numbers of the given MPDU and of all the QoS data frames included in
+   *         the given TX parameters
+   */
+  uint16_t GetMaxDistFromStartingSeq (Ptr<const WifiMacQueueItem> mpdu,
+                                      const WifiTxParameters& txParams) const;
+
+protected:
+  /**
+   * Determine whether the (A-)MPDU containing the given MPDU and the MPDUs (if any)
+   * included in the given TX parameters requires an immediate response (Normal Ack,
+   * Block Ack or Block Ack Request followed by Block Ack).
+   *
+   * \param mpdu the given MPDU.
+   * \param txParams the given TX parameters.
+   * \return true if the given PSDU requires an immediate response
+   */
+  bool IsResponseNeeded (Ptr<const WifiMacQueueItem> mpdu,
+                         const WifiTxParameters& txParams) const;
+private:
+  /**
+   * Compute the information about the acknowledgment of the current multi-user frame
+   * (as described by the given TX parameters) if the given MPDU is added. If the
+   * computed information is the same as the current one, a null pointer is returned.
+   * Otherwise, the computed information is returned.
+   * This method can only be called if the selected acknowledgment method for DL
+   * multi-user frames consists of a sequence of BlockAckReq and BlockAck frames.
+   *
+   * \param mpdu the given MPDU
+   * \param txParams the TX parameters describing the current multi-user frame
+   * \return the new acknowledgment method or a null pointer if the acknowledgment method
+   *         is unchanged
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfBarBaSequence (Ptr<const WifiMacQueueItem> mpdu,
+                                                                         const WifiTxParameters& txParams);
+  /**
+   * Compute the information about the acknowledgment of the current multi-user frame
+   * (as described by the given TX parameters) if the given MPDU is added. If the
+   * computed information is the same as the current one, a null pointer is returned.
+   * Otherwise, the computed information is returned.
+   * This method can only be called if the selected acknowledgment method for DL
+   * multi-user frames consists of a MU-BAR Trigger Frame sent as single-user frame.
+   *
+   * \param mpdu the given MPDU
+   * \param txParams the TX parameters describing the current multi-user frame
+   * \return the new acknowledgment method or a null pointer if the acknowledgment method
+   *         is unchanged
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfTfMuBar (Ptr<const WifiMacQueueItem> mpdu,
+                                                                   const WifiTxParameters& txParams);
+  /**
+   * Compute the information about the acknowledgment of the current multi-user frame
+   * (as described by the given TX parameters) if the given MPDU is added. If the
+   * computed information is the same as the current one, a null pointer is returned.
+   * Otherwise, the computed information is returned.
+   * This method can only be called if the selected acknowledgment method for DL
+   * multi-user frames consists of MU-BAR Trigger Frames aggregated to the PSDUs of
+   * the MU PPDU.
+   *
+   * \param mpdu the given MPDU
+   * \param txParams the TX parameters describing the current multi-user frame
+   * \return the new acknowledgment method or a null pointer if the acknowledgment method
+   *         is unchanged
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfAggregatedMuBar (Ptr<const WifiMacQueueItem> mpdu,
+                                                                           const WifiTxParameters& txParams);
+
+  /**
+   * Calculate the acknowledgment method for the TB PPDUs solicited by the given
+   * Trigger Frame.
+   *
+   * \param mpdu the given Trigger Frame
+   * \param txParams the current TX parameters (just the TXVECTOR needs to be set)
+   * \return the acknowledgment method for the TB PPDUs solicited by the given Trigger Frame
+   */
+  virtual std::unique_ptr<WifiAcknowledgment> TryUlMuTransmission (Ptr<const WifiMacQueueItem> mpdu,
+                                                                   const WifiTxParameters& txParams);
+
+  bool m_useExplicitBar;                    //!< true for sending BARs, false for using Implicit BAR policy
+  double m_baThreshold;                     //!< Threshold to determine when a BlockAck must be requested
+  WifiAcknowledgment::Method m_dlMuAckType; //!< Type of the ack sequence for DL MU PPDUs
+  uint8_t m_maxMcsForBlockAckInTbPpdu;      //!< Max MCS used to send a BlockAck in a TB PPDU
+};
+
+
+
+} //namespace ns3
+
+#endif /* WIFI_DEFAULT_ACK_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-default-protection-manager.cc ns-3.34/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.33/src/wifi/model/wifi-default-protection-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-default-protection-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,151 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "wifi-default-protection-manager.h"
+#include "wifi-tx-parameters.h"
+#include "wifi-mac-queue-item.h"
+#include "regular-wifi-mac.h"
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WifiDefaultProtectionManager");
+
+NS_OBJECT_ENSURE_REGISTERED (WifiDefaultProtectionManager);
+
+TypeId
+WifiDefaultProtectionManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::WifiDefaultProtectionManager")
+    .SetParent<WifiProtectionManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<WifiDefaultProtectionManager> ()
+  ;
+  return tid;
+}
+
+WifiDefaultProtectionManager::WifiDefaultProtectionManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WifiDefaultProtectionManager::~WifiDefaultProtectionManager ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+std::unique_ptr<WifiProtection>
+WifiDefaultProtectionManager::TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu,
+                                          const WifiTxParameters& txParams)
+{
+  NS_LOG_FUNCTION (this << *mpdu << &txParams);
+
+  // if the current protection method (if any) is already RTS/CTS or CTS-to-Self,
+  // it will not change by adding an MPDU
+  if (txParams.m_protection
+      && (txParams.m_protection->method == WifiProtection::RTS_CTS
+          || txParams.m_protection->method == WifiProtection::CTS_TO_SELF))
+    {
+      return nullptr;
+    }
+
+  // if a protection method is set, it must be NONE
+  NS_ASSERT (!txParams.m_protection || txParams.m_protection->method == WifiProtection::NONE);
+
+  std::unique_ptr<WifiProtection> protection;
+  protection = GetPsduProtection (mpdu->GetHeader (), txParams.GetSizeIfAddMpdu (mpdu),
+                                  txParams.m_txVector);
+
+  // return the newly computed method if none was set or it is not NONE
+  if (!txParams.m_protection || protection->method != WifiProtection::NONE)
+    {
+      return protection;
+    }
+  // the protection method has not changed
+  return nullptr;
+}
+
+std::unique_ptr<WifiProtection>
+WifiDefaultProtectionManager::TryAggregateMsdu (Ptr<const WifiMacQueueItem> msdu,
+                                                const WifiTxParameters& txParams)
+{
+  NS_LOG_FUNCTION (this << *msdu << &txParams);
+
+  // if the current protection method is already RTS/CTS or CTS-to-Self,
+  // it will not change by aggregating an MSDU
+  NS_ASSERT (txParams.m_protection);
+  if (txParams.m_protection->method == WifiProtection::RTS_CTS
+      || txParams.m_protection->method == WifiProtection::CTS_TO_SELF)
+    {
+      return nullptr;
+    }
+
+  NS_ASSERT (txParams.m_protection->method == WifiProtection::NONE);
+
+  std::unique_ptr<WifiProtection> protection;
+  protection = GetPsduProtection (msdu->GetHeader (), txParams.GetSizeIfAggregateMsdu (msdu).second,
+                                  txParams.m_txVector);
+
+  // the protection method may still be none
+  if (protection->method == WifiProtection::NONE)
+    {
+      return nullptr;
+    }
+
+  // the protection method has changed
+  return protection;
+}
+
+std::unique_ptr<WifiProtection>
+WifiDefaultProtectionManager::GetPsduProtection (const WifiMacHeader& hdr, uint32_t size,
+                                                 const WifiTxVector& txVector) const
+{
+  NS_LOG_FUNCTION (this << hdr << size << txVector);
+
+  // a non-initial fragment does not need to be protected, unless it is being retransmitted
+  if (hdr.GetFragmentNumber () > 0 && !hdr.IsRetry ())
+    {
+      return std::unique_ptr<WifiProtection> (new WifiNoProtection ());
+    }
+
+  // check if RTS/CTS is needed
+  if (m_mac->GetWifiRemoteStationManager ()->NeedRts (hdr, size))
+    {
+      WifiRtsCtsProtection* protection = new WifiRtsCtsProtection;
+      protection->rtsTxVector = m_mac->GetWifiRemoteStationManager ()->GetRtsTxVector (hdr.GetAddr1 ());
+      protection->ctsTxVector = m_mac->GetWifiRemoteStationManager ()->GetCtsTxVector (hdr.GetAddr1 (),
+                                                                                       protection->rtsTxVector.GetMode ());
+      return std::unique_ptr<WifiProtection> (protection);
+    }
+
+  // check if CTS-to-Self is needed
+  if (m_mac->GetWifiRemoteStationManager ()->GetUseNonErpProtection ()
+      && m_mac->GetWifiRemoteStationManager ()->NeedCtsToSelf (txVector))
+    {
+      WifiCtsToSelfProtection* protection = new WifiCtsToSelfProtection;
+      protection->ctsTxVector = m_mac->GetWifiRemoteStationManager ()->GetCtsToSelfTxVector ();
+      return std::unique_ptr<WifiProtection> (protection);
+    }
+
+  return std::unique_ptr<WifiProtection> (new WifiNoProtection ());
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-default-protection-manager.h ns-3.34/src/wifi/model/wifi-default-protection-manager.h
--- ns-3.33/src/wifi/model/wifi-default-protection-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-default-protection-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,71 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_DEFAULT_PROTECTION_MANAGER_H
+#define WIFI_DEFAULT_PROTECTION_MANAGER_H
+
+#include "wifi-protection-manager.h"
+
+
+namespace ns3 {
+
+class WifiTxParameters;
+class WifiMacQueueItem;
+class WifiMacHeader;
+
+/**
+ * \ingroup wifi
+ *
+ * WifiDefaultProtectionManager is the default protection manager, which selects
+ * the protection method for a frame based on its size.
+ */
+class WifiDefaultProtectionManager : public WifiProtectionManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  WifiDefaultProtectionManager ();
+  virtual ~WifiDefaultProtectionManager ();
+
+  virtual std::unique_ptr<WifiProtection> TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu,
+                                                      const WifiTxParameters& txParams) override;
+  virtual std::unique_ptr<WifiProtection> TryAggregateMsdu (Ptr<const WifiMacQueueItem> msdu,
+                                                            const WifiTxParameters& txParams) override;
+
+protected:
+  /**
+   * Select the protection method for a single PSDU.
+   *
+   * \param hdr the MAC header of the PSDU
+   * \param size the size in bytes of the PSDU
+   * \param txVector the TxVector used to transmit the PSDU
+   * \return the selected protection method
+   */
+  virtual std::unique_ptr<WifiProtection> GetPsduProtection (const WifiMacHeader& hdr, uint32_t size,
+                                                             const WifiTxVector& txVector) const;
+};
+
+} //namespace ns3
+
+#endif /* WIFI_DEFAULT_PROTECTION_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-information-element.h ns-3.34/src/wifi/model/wifi-information-element.h
--- ns-3.33/src/wifi/model/wifi-information-element.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-information-element.h	2021-07-14 10:31:07.000000000 -0700
@@ -239,7 +239,7 @@
    *
    * \return an iterator
    */
-  Buffer::Iterator Serialize (Buffer::Iterator i) const;
+  virtual Buffer::Iterator Serialize (Buffer::Iterator i) const;
   /**
    * Deserialize entire IE, which must be present. The iterator
    * passed in must be pointing at the Element ID (i.e., the very
@@ -268,7 +268,7 @@
    *
    * \return the size of the serialized IE in bytes
    */
-  uint16_t GetSerializedSize () const;
+  virtual uint16_t GetSerializedSize () const;
 
   // Each subclass must implement these pure virtual functions:
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-information-element-vector.h ns-3.34/src/wifi/model/wifi-information-element-vector.h
--- ns-3.33/src/wifi/model/wifi-information-element-vector.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-information-element-vector.h	2021-07-14 10:31:07.000000000 -0700
@@ -47,9 +47,10 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId ();
-  TypeId GetInstanceTypeId () const;
-  virtual uint32_t GetSerializedSize () const;
-  virtual void Serialize (Buffer::Iterator start) const;
+
+  TypeId GetInstanceTypeId () const override;
+  uint32_t GetSerializedSize () const override;
+  void Serialize (Buffer::Iterator start) const override;
   /**
    * \attention This variant should not be used but is implemented due to
    * backward compatibility reasons
@@ -57,7 +58,7 @@
    * \param start buffer location to start deserializing from
    * \return number of bytes deserialized
    */
-  virtual uint32_t Deserialize (Buffer::Iterator start);
+  uint32_t Deserialize (Buffer::Iterator start) override;
   /**
    * Deserialize a number of WifiInformationElements 
    *
@@ -67,8 +68,8 @@
    * \param end ending buffer location
    * \return number of bytes deserialized
    */
-  virtual uint32_t Deserialize (Buffer::Iterator start, Buffer::Iterator end);
-  virtual void Print (std::ostream &os) const;
+  uint32_t Deserialize (Buffer::Iterator start, Buffer::Iterator end) override;
+  void Print (std::ostream &os) const override;
 
   /**
    * \brief Needed when you try to deserialize a lonely IE inside other header
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac.cc ns-3.34/src/wifi/model/wifi-mac.cc
--- ns-3.33/src/wifi/model/wifi-mac.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -24,9 +24,9 @@
 #include "txop.h"
 #include "ssid.h"
 #include "wifi-net-device.h"
-#include "ht-configuration.h"
-#include "vht-configuration.h"
-#include "he-configuration.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/vht-configuration.h"
+#include "ns3/he-configuration.h"
 
 namespace ns3 {
 
@@ -51,7 +51,10 @@
                      MakeTraceSourceAccessor (&WifiMac::m_macTxTrace),
                      "ns3::Packet::TracedCallback")
     .AddTraceSource ("MacTxDrop",
-                     "A packet has been dropped in the MAC layer before transmission.",
+                     "A packet has been dropped in the MAC layer before being queued for transmission. "
+                     "This trace source is fired, e.g., when an AP's MAC receives from the upper layer "
+                     "a packet destined to a station that is not associated with the AP or a STA's MAC "
+                     "receives a packet from the upper layer while it is not associated with any AP.",
                      MakeTraceSourceAccessor (&WifiMac::m_macTxDropTrace),
                      "ns3::Packet::TracedCallback")
     .AddTraceSource ("MacPromiscRx",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac.h ns-3.34/src/wifi/model/wifi-mac.h
--- ns-3.33/src/wifi/model/wifi-mac.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -35,6 +35,30 @@
 class HeConfiguration;
 
 /**
+ * Enumeration for type of station
+ */
+enum TypeOfStation
+{
+  STA,
+  AP,
+  ADHOC_STA,
+  MESH,
+  OCB
+};
+
+/**
+ * \ingroup wifi
+  * \enum WifiMacDropReason
+  * \brief The reason why an MPDU was dropped
+  */
+enum WifiMacDropReason : uint8_t
+{
+  WIFI_MAC_DROP_FAILED_ENQUEUE = 0,
+  WIFI_MAC_DROP_EXPIRED_LIFETIME,
+  WIFI_MAC_DROP_REACHED_RETRY_LIMIT
+};
+
+/**
  * \brief base class for all MAC-level wifi objects.
  * \ingroup wifi
  *
@@ -67,7 +91,22 @@
    */
   Ptr<NetDevice> GetDevice (void) const;
 
+   /**
+   * This method is invoked by a subclass to specify what type of
+   * station it is implementing. This is something that the channel
+   * access functions need to know.
+   *
+   * \param type the type of station.
+   */
+  virtual void SetTypeOfStation (TypeOfStation type) = 0;
   /**
+   * Return the type of station.
+   *
+   * \return the type of station.
+   */
+  virtual TypeOfStation GetTypeOfStation (void) const = 0;
+
+ /**
    * \param ssid the current SSID of this MAC layer.
    */
   virtual void SetSsid (Ssid ssid) = 0;
@@ -159,10 +198,20 @@
   virtual Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const = 0;
 
   /**
+   * This type defines the callback of a higher layer that a
+   * WifiMac(-derived) object invokes to pass a packet up the stack.
+   *
+   * \param packet the packet that has been received.
+   * \param from the MAC address of the device that sent the packet.
+   * \param to the MAC address of the device that the packet is destined for.
+   */
+  typedef Callback<void, Ptr<const Packet>, Mac48Address, Mac48Address> ForwardUpCallback;
+
+  /**
    * \param upCallback the callback to invoke when a packet must be
    *        forwarded up the stack.
    */
-  virtual void SetForwardUpCallback (Callback<void, Ptr<const Packet>, Mac48Address, Mac48Address> upCallback) = 0;
+  virtual void SetForwardUpCallback (ForwardUpCallback upCallback) = 0;
   /**
    * \param linkUp the callback to invoke when the link becomes up.
    */
@@ -186,9 +235,9 @@
   /**
    * \param packet the packet being dropped
    *
-   * Public method used to fire a MacTxDrop trace. Implemented for encapsulation purposes.
-   * This trace indicates that the packet was dropped before it was transmitted
-   * (e.g. when a STA is not associated with an AP).
+   * Public method used to fire a MacTxDrop trace.
+   * This trace indicates that the packet was dropped before it was queued for
+   * transmission (e.g. when a STA is not associated with an AP).
    */
   void NotifyTxDrop (Ptr<const Packet> packet);
   /**
@@ -258,7 +307,7 @@
   TracedCallback<Ptr<const Packet> > m_macTxTrace;
   /**
    * The trace source fired when packets coming into the "top" of the device
-   * are dropped at the MAC layer during transmission.
+   * are dropped at the MAC layer before being queued for transmission.
    *
    * \see class CallBackTraceSource
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-header.cc ns-3.34/src/wifi/model/wifi-mac-header.cc
--- ns-3.33/src/wifi/model/wifi-mac-header.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-header.cc	2021-07-14 10:31:07.000000000 -0700
@@ -39,7 +39,12 @@
 /// subtype enumeration
 enum
 {
-  //Reserved: 0 - 6
+  //Reserved: 0 - 1
+  SUBTYPE_CTL_TRIGGER = 2,
+  //Reserved: 3
+  SUBTYPE_CTL_BEAMFORMINGRPOLL = 4,
+  SUBTYPE_CTL_NDPANNOUNCE = 5,
+  SUBTYPE_CTL_CTLFRAMEEXT = 6,
   SUBTYPE_CTL_CTLWRAPPER = 7,
   SUBTYPE_CTL_BACKREQ = 8,
   SUBTYPE_CTL_BACKRESP = 9,
@@ -51,13 +56,26 @@
 };
 
 WifiMacHeader::WifiMacHeader ()
-  : m_ctrlMoreData (0),
+  : m_ctrlMoreFrag (0),
+    m_ctrlRetry (0),
+    m_ctrlMoreData (0),
     m_ctrlWep (0),
     m_ctrlOrder (0),
+    m_duration (0),
+    m_seqFrag (0),
+    m_seqSeq (0),
+    m_qosEosp (0),
+    m_qosAckPolicy (0),  // Normal Ack
     m_amsduPresent (0)
 {
 }
 
+WifiMacHeader::WifiMacHeader (WifiMacType type)
+  : WifiMacHeader ()
+{
+  SetType (type);
+}
+
 WifiMacHeader::~WifiMacHeader ()
 {
 }
@@ -115,6 +133,10 @@
 {
   switch (type)
     {
+    case WIFI_MAC_CTL_TRIGGER:
+      m_ctrlType = TYPE_CTL;
+      m_ctrlSubtype = SUBTYPE_CTL_TRIGGER;
+      break;
     case WIFI_MAC_CTL_CTLWRAPPER:
       m_ctrlType = TYPE_CTL;
       m_ctrlSubtype = SUBTYPE_CTL_CTLWRAPPER;
@@ -376,6 +398,13 @@
   m_qosStuff = txop;
 }
 
+void
+WifiMacHeader::SetQosQueueSize (uint8_t size)
+{
+  m_qosEosp = 1;
+  m_qosStuff = size;
+}
+
 void WifiMacHeader::SetQosMeshControlPresent (void)
 {
   //Mark bit 0 of this variable instead of bit 8, since m_qosStuff is
@@ -454,6 +483,8 @@
     case TYPE_CTL:
       switch (m_ctrlSubtype)
         {
+        case SUBTYPE_CTL_TRIGGER:
+          return WIFI_MAC_CTL_TRIGGER;
         case SUBTYPE_CTL_BACKREQ:
           return WIFI_MAC_CTL_BACKREQ;
         case SUBTYPE_CTL_BACKRESP:
@@ -718,6 +749,12 @@
   return (GetType () == WIFI_MAC_CTL_BACKRESP) ? true : false;
 }
 
+bool
+WifiMacHeader::IsTrigger (void) const
+{
+  return (GetType () == WIFI_MAC_CTL_TRIGGER) ? true : false;
+}
+
 uint16_t
 WifiMacHeader::GetRawDuration (void) const
 {
@@ -828,6 +865,13 @@
   return m_qosTid;
 }
 
+uint8_t
+WifiMacHeader::GetQosQueueSize (void) const
+{
+  NS_ASSERT (m_qosEosp == 1);
+  return m_qosStuff;
+}
+
 uint16_t
 WifiMacHeader::GetFrameControl (void) const
 {
@@ -900,6 +944,7 @@
         case SUBTYPE_CTL_RTS:
         case SUBTYPE_CTL_BACKREQ:
         case SUBTYPE_CTL_BACKRESP:
+        case SUBTYPE_CTL_TRIGGER:
         case SUBTYPE_CTL_END:
         case SUBTYPE_CTL_END_ACK:
           size = 2 + 2 + 6 + 6;
@@ -945,6 +990,7 @@
       FOO (CTL_BACKRESP);
       FOO (CTL_END);
       FOO (CTL_END_ACK);
+      FOO (CTL_TRIGGER);
 
       FOO (MGT_BEACON);
       FOO (MGT_ASSOCIATION_REQUEST);
@@ -1018,6 +1064,7 @@
   switch (GetType ())
     {
     case WIFI_MAC_CTL_RTS:
+    case WIFI_MAC_CTL_TRIGGER:
       os << "Duration/ID=" << m_duration << "us"
          << ", RA=" << m_addr1 << ", TA=" << m_addr2;
       break;
@@ -1127,6 +1174,7 @@
       switch (m_ctrlSubtype)
         {
         case SUBTYPE_CTL_RTS:
+        case SUBTYPE_CTL_TRIGGER:
         case SUBTYPE_CTL_BACKREQ:
         case SUBTYPE_CTL_BACKRESP:
         case SUBTYPE_CTL_END:
@@ -1182,6 +1230,7 @@
       switch (m_ctrlSubtype)
         {
         case SUBTYPE_CTL_RTS:
+        case SUBTYPE_CTL_TRIGGER:
         case SUBTYPE_CTL_BACKREQ:
         case SUBTYPE_CTL_BACKRESP:
         case SUBTYPE_CTL_END:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-mac-header.h ns-3.34/src/wifi/model/wifi-mac-header.h
--- ns-3.33/src/wifi/model/wifi-mac-header.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-mac-header.h	2021-07-14 10:31:07.000000000 -0700
@@ -35,7 +35,8 @@
  */
 enum WifiMacType
 {
-  WIFI_MAC_CTL_CTLWRAPPER = 0,
+  WIFI_MAC_CTL_TRIGGER = 0,
+  WIFI_MAC_CTL_CTLWRAPPER,
   WIFI_MAC_CTL_RTS,
   WIFI_MAC_CTL_CTS,
   WIFI_MAC_CTL_ACK,
@@ -106,6 +107,12 @@
   };
 
   WifiMacHeader ();
+  /**
+   * Construct a MAC header of the given type
+   *
+   * \param type the MAC header type
+   */
+  WifiMacHeader (WifiMacType type);
   virtual ~WifiMacHeader ();
 
   /**
@@ -113,11 +120,12 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
-  void Print (std::ostream &os) const;
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (Buffer::Iterator start) const;
-  uint32_t Deserialize (Buffer::Iterator start);
+
+  TypeId GetInstanceTypeId (void) const override;
+  void Print (std::ostream &os) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (Buffer::Iterator start) const override;
+  uint32_t Deserialize (Buffer::Iterator start) override;
 
   /**
    * Set the From DS bit in the Frame Control field.
@@ -250,6 +258,12 @@
    */
   void SetQosTxopLimit (uint8_t txop);
   /**
+   * Set the Queue Size subfield in the QoS control field.
+   *
+   * \param size the value for the Queue Size subfield
+   */
+  void SetQosQueueSize (uint8_t size);
+  /**
    * Set the Mesh Control Present flag for the QoS header.
    */
   void SetQosMeshControlPresent ();
@@ -387,6 +401,12 @@
    */
   bool IsBlockAck (void) const;
   /**
+   * Return true if the header is a Trigger header.
+   *
+   * \return true if the header is a Trigger header, false otherwise
+   */
+  bool IsTrigger (void) const;
+  /**
    * Return true if the header is an Association Request header.
    *
    * \return true if the header is an Association Request header, false otherwise
@@ -545,6 +565,12 @@
    */
   QosAckPolicy GetQosAckPolicy (void) const;
   /**
+   * Get the Queue Size subfield in the QoS control field.
+   *
+   * \return the value of the Queue Size subfield
+   */
+  uint8_t GetQosQueueSize (void) const;
+  /**
    * Return the size of the WifiMacHeader in octets.
    * GetSerializedSize calls this function.
    *
